

import clay.Entity;
import clay.Vector;

import clay.structural.Pool;

import physics.Contact;
import physics.PointMass;
import processors.BroadPhaseProcessor;


class Physics {


	@:noCompletion public static var broadPhase : BroadPhaseProcessor;

	public static var contactsCount:Int = 0;
	public static var contactsPool:Pool<Contact> = new Pool( 100, function() { return new Contact(); });


	public static function init() {
		
	    broadPhase = Clay.world.processors.get(BroadPhaseProcessor);

	}

// collision api

// Area
	public static inline function AreaOverlap(pointA:Vector, pointB:Vector, ?layerMask:Int = -1):Bool{

		return broadPhase.getAreaOverlap(pointA, pointB, layerMask);

	}

	public static inline function AreaOverlapNearest(pointA:Vector, pointB:Vector, ?layerMask:Int = -1):PointMass{

		return broadPhase.getAreaOverlapNearest(pointA, pointB, layerMask);

	}

	public static inline function AreaOverlapAll(pointA:Vector, pointB:Vector, ?into:Array<PointMass>, ?layerMask:Int = -1):Array<PointMass>{

		return broadPhase.getAreaOverlapAll(pointA, pointB, into, layerMask);

	}


}
