package components.player;


import clay.Vector;
import clay.IComponent;
// import physics.PointMass;
import physics.Line;


class SurfboardComponent implements IComponent {
	
	// public var pmA:PointMass;
	// public var pmB:PointMass;

	public var line:Line;
	public var inertia(default, set):Float;
	public var invInertia:Float;
	public var angularVelocity:Float = 0;
	public var angularDamping:Float = 0.01;
	public var velocity:Vector;
	public var gravity:Float = 256;

	// mass of thie PointMass.
	public var mass(default, set):Float;
	// The inverse of PointMass.mMass.
	public var invMass(default, null):Float;


	public function new() {

		mass = 1;
		inertia = 0.5;

	}

	function set_inertia(value:Float):Float {

		if(value > 0) {
			invInertia = 1 / value;
		} else {
			invInertia = 0;
			value = 0;
		}

		return inertia = value;

	}

	inline function set_mass(_value:Float):Float{

		if(_value > 0 ){
			mass = _value;
			invMass = 1.0 / mass;
		} else {
			mass = 0;
			invMass = 0;
		}

		return mass;

	}

}
