package effects;


import clay.Color;
import clay.Vector;

import phoenix.RenderTexture;
import phoenix.Batcher;
import phoenix.geometry.QuadGeometry;


class Effect {


	public var name(default, null):String;

	var clearColour:Color;
	var outputBatcher:Batcher;
	var outputGeometry:QuadGeometry;


	public function new(_name:String) {

		clearColour = new Color(0,0,0,0);
		name = _name;

	}

	public function onload() {

		setupGeometry();

	}

	public function update(dt:Float) {}

	public function apply(preTexture:RenderTexture, postTexture:RenderTexture) {

		Clay.renderer.target = postTexture;
		Clay.renderer.clear(clearColour);

		outputGeometry.texture = preTexture;
		outputBatcher.draw();

	}

	function setupGeometry() {

		outputBatcher = Clay.renderer.create_batcher({
			name: 'batcher.effect.' + name,
			no_add: true
		});

		outputBatcher.view.viewport = Clay.camera.viewport;

		outputGeometry = new QuadGeometry({
			x:0,
			y:0,
			w:Clay.screen.size.x,
			h:Clay.screen.size.y,
			batcher: outputBatcher,
		});

	}

}
