package physics;

import clay.Vector;
import utils.ShapeDrawer;


class Bounds{


	public var max : Vector;
	public var min : Vector;


	public function new(_min:Vector = null, _max:Vector = null) {

		min = _min != null ? _min : new Vector();
		max = _max != null ? _max : new Vector();

	}

	public function contains( _p:Vector ) {

		if (_p.x < min.x || _p.x > max.x) return false;
		if (_p.y < min.y || _p.y > max.y) return false;

		return true;

	}

	public function intersects( _other:Bounds ) {

		if ( _other.max.x < min.x || _other.min.x > max.x ) return false;
		if ( _other.max.y < min.y || _other.min.y > max.y ) return false;

		return true;

	}

	public function intersectsMinMax( _min:Vector, _max:Vector ) {

		if ( _max.x < min.x || _min.x > max.x ) return false;
		if ( _max.y < min.y || _min.y > max.y ) return false;

		return true;

	}

	public function setFromSize( size:Vector, _add:Float = 0 ) {
		
		var sx:Float = size.x * 0.5 + _add;
		var sy:Float = size.y * 0.5 + _add;

		min.x = -sx;
		min.y = -sy;
		max.x = sx;
		max.y = sy;
		
	}

	public function copyFrom( _other:Bounds ) {

		min.x = _other.min.x;
		min.y = _other.min.y;
		max.x = _other.max.x;
		max.y = _other.max.y;

	}

	public function clone():Bounds{

		return new Bounds(min.clone(), max.clone());

	}

	public inline function draw(){

		ShapeDrawer.drawBox_MinMax(min, max, ShapeDrawer.color_white);  

	}

	public function destroy(){

		max = null;
		min = null;

	}

	
}
