package physics;

import clay.Vector;
import phoenix.Matrix;

/** A polygonal collision shape */
class Line extends Shape {

	public var p0(get, never):Vector;
	public var p1(get, never):Vector;

	var _p0:Vector;
	var _p1:Vector;

	var _transformed_p0:Vector;
	var _transformed_p1:Vector;


		/** Create a new polygon with a given set of vertices at position x,y. */
	public function new( x:Float, y:Float, width:Float) {

		super( x,y );

		name = 'line';

		_p0 = new Vector(-width/2, 0);
		_p1 = new Vector(width/2, 0);

		_transformed_p0 = _p0.clone();
		_transformed_p1 = _p1.clone();


	} //new

		/** Destroy this polygon and clean up. */
	override public function destroy() : Void {
		
		_p0 = null;
		_p1 = null;

		super.destroy();

	} //destroy

//Internal

	inline function get_p0() : Vector {

		_transformed_p0 = transformVector(_p0.clone(), _transformMatrix);
		_transformed_p1 = transformVector(_p1.clone(), _transformMatrix);

		return _transformed_p0;
	}

	inline function get_p1() : Vector {

		_transformed_p0 = transformVector(_p0.clone(), _transformMatrix);
		_transformed_p1 = transformVector(_p1.clone(), _transformMatrix);
		
		return _transformed_p1;

	}

}
