package physics;

import clay.Vector;
import utils.ShapeDrawer;


class PointMassList {


	public var head (default, null) : PointMass;
	public var tail (default, null) : PointMass;

	public var length(default, null):Int = 0;

	public function new(){}


	public inline function addFirst(p:PointMass) {

		p.next = head;
		if (head != null){
			head.prev = p;
		} else {
			tail = p;
		}

		head = p;
		
		length++;

	}

	public inline function addLast(p:PointMass) {

		if (tail != null) {
			tail.next = p;
			p.prev = tail;
		} else{
			head = p;
		}

		tail = p;
		
		length++;

	}

	public inline function remFirst() : PointMass {
		
		var node = head;
		if (head == tail){
			head = tail = null;
		} else {
			head = head.next;
			node.next = null;
			head.prev = null;
		}

		length--;

		return node;

	}

	public inline function remLast() : PointMass {
		
		var node = tail;
		if (head == tail){
			head = tail = null;
		} else {
			tail = tail.prev;
			node.prev = null;
			tail.next = null;
		}
		
		length--;

		return node;

	}

	public inline function remNode(node:PointMass) {
		
		if (node == head){
			head = head.next;
			
			if (head == null) {
				tail = null;
			}
		} else if (node == tail) {
			tail = tail.prev;
				
			if (tail == null) {
				head = null;
			}
		}

		if (node.prev != null) {
			node.prev.next = node.next;
		}

		if (node.next != null) {
			node.next.prev = node.prev;
		}

		node.next = node.prev = null;

		length--;

	}

	public function clear() : Void {

		var p:PointMass = null;
		while (head != null) {
			p = head;
			head = head.next;
			p.prev = null;
			p.next = null;
		}

		tail = null;
		
		length = 0;

	}

}


