package physics.collision;

import clay.Vector;

import physics.RayIntersection;


class IntersectLineLine {


    public static function test( start1:Vector, end1:Vector, start2:Vector, end2:Vector, ?into:RayIntersection ) : RayIntersection {

		var delta1X:Float = end1.x - start1.x;
		var delta1Y:Float = end1.y - start1.y;

		var delta2X:Float = end2.x - start2.x;
		var delta2Y:Float = end2.y - start2.y;

        var diffX:Float = start1.x - start2.x;
        var diffY:Float = start1.y - start2.y;

        var ud:Float = delta2Y * delta1X - delta2X * delta1Y;

        if(ud == 0.0) {
            return null;
        }

        var u1:Float = (delta2X * diffY - delta2Y * diffX) / ud;
        var u2:Float = (delta1X * diffY - delta1Y * diffX) / ud;

        if ((u1 > 0.0 && u1 <= 1) && (u2 > 0.0 && u2 <= 1)) {
            into = (into == null) ? new RayIntersection() : into.reset();

                into.centroid1.x = start1.x;
                into.centroid1.y = start1.y;

                into.centroid2.x = start2.x;
                into.centroid2.y = start2.y;

                into.fraction1 = u1;
                into.fraction2 = u2;

            	var dx:Float = delta1X * u1;
				var dy:Float = delta1Y * u1;

                into.point.x = start1.x + dx;
	        	into.point.y = start1.y + dy;

            	into.distance1 = Math.sqrt(dx * dx + dy * dy);

				dx = delta2X * u2;
				dy = delta2Y * u2;

            	into.distance2 = Math.sqrt(dx * dx + dy * dy);

            return into;
        }

        return null;

    }

}
