package physics.collision;

import clay.Vector;

import physics.collision.data.RayIntersection;

class IntersectRayLine {


    public static function test( r1pos:Vector, r1dir:Vector, r1dist:Float, lineStart:Vector, lineEnd:Vector, ?into:RayIntersection ) : RayIntersection {

        var end1:Float = 1;
        
		if(!Math.isFinite(r1dist)){
			r1dist = 1;
        	end1 = Math.POSITIVE_INFINITY;
		}

		var delta1X:Float = r1dir.x * r1dist;
		var delta1Y:Float = r1dir.y * r1dist;

		var delta2X:Float = lineEnd.x - lineStart.x;
		var delta2Y:Float = lineEnd.y - lineStart.y;

        var diffX:Float = r1pos.x - lineStart.x;
        var diffY:Float = r1pos.y - lineStart.y;

        var ud:Float = delta2Y * delta1X - delta2X * delta1Y;

        if(ud == 0.0) {
            return null;
        }

        var u1:Float = (delta2X * diffY - delta2Y * diffX) / ud;
        var u2:Float = (delta1X * diffY - delta1Y * diffX) / ud;

        if ((u1 > 0.0 && u1 <= end1) && (u2 > 0.0 && u2 <= 1)) {
            into = (into == null) ? new RayIntersection() : into.reset();

                into.centroid1.x = r1pos.x;
                into.centroid1.y = r1pos.y;

                into.centroid2.x = lineStart.x;
                into.centroid2.y = lineStart.y;

                into.fraction1 = u1;
                into.fraction2 = u2;

            	var dx:Float = delta1X * u1;
				var dy:Float = delta1Y * u1;

                into.point.x = r1pos.x + dx;
	        	into.point.y = r1pos.y + dy;

            	into.distance1 = Math.sqrt(dx * dx + dy * dy);

				dx = delta2X * u2;
				dy = delta2Y * u2;

            	into.distance2 = Math.sqrt(dx * dx + dy * dy);

            return into;
        }

        return null;

    }


}
